#include <cstdio>
#include <cuda_runtime.h>
#include <cublas_v2.h>
#include "helper_cuda.h"
                                           
//helper_cuda.h contains the error checking macros. note that they're called
//CUDA_CALL and CUBLAS_CALL instead of the previous names


//TODO: perform the following matrix multiplications using cublas

#define M 2 // 
#define N 3
#define IDX2C(i,j,ld) (((j)*(ld))+(i))

int main(int argc, char *argv[]) {
    int A[N * M] = {1, 2, 3, 4, 5, 6};
    int B[M * N] = {1, 2, 3, 4, 5, 6};
    int res1[N * N];
    int res2[M * M];

    int i, j, k;

    //TODO: cudaMalloc buffers, copy these to device, etc.

    // A * B
    // TODO: do this on GPU too with cuBLAS, copy result back, and printf it to check
    printf("A * B\n");
    for (i = 0; i < N; i++) {
        for (j = 0; j < N; j++) {
            res1[IDX2C(i, j, N)] = 0;
            for (k = 0; k < M; k++) {
                res1[IDX2C(i, j, N)] += A[IDX2C(i, k, N)] * B[IDX2C(k, j, M)];
            }
            printf("[%d, %d] = %d\n", i, j, res1[IDX2C(i, j, N)]);
        }
    }

    // A^T * B^T
    // TODO: do this on GPU too with cuBLAS, copy result back, and printf to check it
    printf("\nA^T * B^T\n");
    for (i = 0; i < M; i++) {
        for (j = 0; j < M; j++) {
            res2[IDX2C(i, j, M)] = 0;
            for (k = 0; k < N; k++) {
                res2[IDX2C(i, j, M)] += A[IDX2C(k, i, N)] * B[IDX2C(j, k, M)];
            }
            printf("[%d, %d] = %d\n", i, j, res2[IDX2C(i, j, M)]);
        }
    }

}